package com.unipi.talepis;

import org.springframework.web.bind.annotation.*;

import java.sql.*;
import java.util.HashMap;
import java.util.Map;

@RestController
public class DBController {
    private static String url = "jdbc:sqlite:src/main/resources/DB/CS2021.db";
    @RequestMapping("/allmodels")
    public String selectModels(){
        StringBuilder builder = new StringBuilder();
        try {
            Connection connection = DriverManager.getConnection(url);
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery("Select Model FROM Smartphone");
            while (resultSet.next()){
               builder.append(resultSet.getString("Model")).append("<br/>");
            }
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
        return builder.toString();
    }
    @GetMapping("/smartphone/{id}")
    public Smartphone show(@PathVariable String id){
        Smartphone smartphone = null;
        try {
            Connection connection = DriverManager.getConnection(url);
            PreparedStatement statement =
                    connection.prepareStatement("SELECT * FROM Smartphone WHERE id=?");
            statement.setString(1,id);
            ResultSet resultSet = statement.executeQuery();
            while (resultSet.next()){
                smartphone = new Smartphone(id,resultSet.getString("Model"),
                        resultSet.getString("Description"),
                        resultSet.getInt("Price"));
            }
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
        return  smartphone;
    }
    @PostMapping("/newsmartphone")
    public Map<String,String> insert(@RequestBody Map<String,String> body){
        String id = body.get("id");
        String model = body.get("model");
        String description = body.get("description");
        int price = Integer.parseInt(body.get("price"));
        try {
            Connection connection = DriverManager.getConnection(url);
            PreparedStatement statement =
                    connection.prepareStatement
                            ("INSERT INTO Smartphone (ID,Model,Description,Price) VALUES (?,?,?,?)");
            statement.setString(1,id);
            statement.setString(2,model);
            statement.setString(3,description);
            statement.setInt(4, price);
            statement.execute();
            connection.close();
        } catch (SQLException throwables) {
            String message = throwables.getLocalizedMessage();
            return new HashMap<String, String>(){{put("message",message);}};
        }
        return new HashMap<String, String>(){{put("message","Smartphone inserted succesfully!");}};
    }
}
